/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"
#include "patches.h"
#include "xcom.h"

#define HEAVY_LASER_MOD

#define INI_FILE "./UFOExtender.ini"
#define INI_READ_INT(section,key,default) GetPrivateProfileIntA(section,key,default,INI_FILE)
#define INI_READ_STRING(section,key,default,buf,size) GetPrivateProfileStringA(section,key,default,buf,size,INI_FILE)

/*
 * Make visible the presence of the loader
 */
void ShowMod()
{
	DrawString("All your base are belong to us",0x8B,52,88,1);
	((void (*)(int))(0x42F680))(1);
}


/*
 * Fix the garbled screen problem by taking into account the surface's pitch
 */
void FixPitch(char *src)
{
	if(char *dst=DD_SurfaceLock())
	{
		IDirectDrawSurface *pSurface=*(IDirectDrawSurface **)0x478604;
		DDSURFACEDESC SurfaceDesc;
		SurfaceDesc.dwSize=sizeof(SurfaceDesc);

		pSurface->GetSurfaceDesc(&SurfaceDesc);
		int pitch=SurfaceDesc.lPitch;

		for(int i=0;i<200;i++)
		{
			memcpy(dst,src,320);
			dst+=pitch;
			src+=320;
		}

		DD_SurfaceUnlock();
		DD_SurfaceFlip();
	}
}

/*
 * Equipment screen mod
 */
void ShowEncumberance(void)
{
	int encumberance=GetUnitEncumberance(*unitIdx);
	unsigned char strength=(*currentUnit_pUnitRef)->Strength;
	unsigned char accuracy=(*currentUnit_pUnitRef)->Firing_Acc;
	unsigned char reaction=(*currentUnit_pUnitRef)->React_Current;
	unsigned char psi_strength=(*currentUnit_pUnitRef)->Psi_Strength;
	unsigned char psi_skill=(*currentUnit_pUnitRef)->Psi_Skill;

	static char weight_str[16];
	static char accuracy_str[16];
	static char reaction_str[16];
	static char psi_strength_str[16];
	static char psi_skill_str[16];
	static int init=0;
	if(init==0) {
		init=1;
		INI_READ_STRING("Equipment Screen","Weight","Weight>",weight_str,16);
		INI_READ_STRING("Equipment Screen","Accuracy","Accur>",accuracy_str,16);
		INI_READ_STRING("Equipment Screen","Reaction","React>",reaction_str,16);
		INI_READ_STRING("Equipment Screen","Psi Strength","P.Str>",psi_skill_str,16);
		INI_READ_STRING("Equipment Screen","Psi Skill","P.Skill>",psi_strength_str,16);
	}

	//Draw weight stats
	DrawString(weight_str,0x40,24,245,1);
	DrawNumber(encumberance,0x10,*carretPosition,1);
	DrawSmallLetter('/',0x40,*carretPosition);
	DrawNumber(strength,0x30,*carretPosition,1);

	//Only draw other stats during equiping phase
	if(*tactical_mainState != 2)
	{
		DrawString(accuracy_str,0x40,32,245,1);
		DrawNumber(accuracy,0x10,*carretPosition,1);

		DrawString(reaction_str,0x40,40,245,1);
		DrawNumber(reaction,0x10,*carretPosition,1);

		//Only draw psi stats when unit has been in psi-lab
		if(psi_skill)
		{
			DrawString(psi_skill_str,0x40,48,245,1);
			DrawNumber(psi_skill,0x10,*carretPosition,1);

			DrawString(psi_strength_str,0x40,56,245,1);
			DrawNumber(psi_strength,0x10,*carretPosition,1);
		}
	}
}

/*
 * The procedure that randomize the shots trajectory is bugged when shooting vertically.
 * We disable it when it is the case to fix the blaster bomb bug.
 */
void FixedAccuracyCompensation()
{
	short x1=*(short *)0x4783F8;
	short y1=*(short *)0x4783FA;
	short x2=*(short *)0x478400;
	short y2=*(short *)0x478402;

	if( x1 == x2 && y1 == y2 ) //vertical shot
		return;

	AdjustShotWithAccuracy();
}

//PSX music stuff in another file because it's quite big
#include "music.cpp"

#ifdef HEAVY_LASER_MOD
//Heavy laser mod in another file too
#include "burst.cpp"
#endif

/*
 * Called when scrolling in tactical mode. This reduces the scroll speed
 */
void TimeFix(int eax)
{
	DWORD tac_time,delta;
	tac_time=timeGetTime();
	((void (*)(int))(0x428970))(eax);
	delta=timeGetTime()-tac_time;

	if(delta<20)
	{
		Sleep(20-delta);
	}
}

/*
 * Called when a facility is destroyed. We update the radar stats to fix the phantom radar bug
 */
void PhantomRadarFix()
{
	UpdateRadarStats(*currentBaseIdx);
}

/*
 * Some hacks to facilitate the work...
 */
void DebugFlagsCheck()
{
#ifdef NDEBUG
	if(INI_READ_INT("Hack","Alien Pets",0))
#endif
	{
		*tac_debug_alienPuppies=2;
	}

#ifdef NDEBUG
	if(INI_READ_INT("Hack","Big Brother",0))
#endif
	{
		*tac_debug=1;
	}
}

/*
 * TU reservation mode
 * We save the mode when ending turn and restore it
 * before the next human turn
 */
static short savedReservedMode=0;
void SaveReserveMode()
{
	savedReservedMode=*tac_currentTUReserveMode;
}
void RestoreReserveMode()
{
	*tac_currentTUReserveMode=savedReservedMode;
}

/*
 * Detect successful ground assault missions and trigger reaction from alien
 */
void RetaliationAfterGroundAssault(void *dstbuf, int filename)
{
	char victoryStatus;
	LoadFile(dstbuf,filename);
	victoryStatus=tac_misdata[0x4e];

	if(victoryStatus == 1) //mission successful
	{
		char locIdx=tac_misdata[0x4c];
		if( ((*locationList+20*locIdx))[0] == 1 ) //Landed UFO have type 1 here, not 6!!!
		{
			char ufoIdx=(*locationList+20*locIdx)[1];
			char craftIdx=tac_misdata[0x4d];
			void *attacker=(void *)(*craftList+104*craftIdx);
			void *ufo=(void *)(*craftList+104*ufoIdx);
			AlienTakeActionAfterShootDown(ufo,attacker);
		}
	}
}

/*
 * Wreck analysis
 * Each navigation module can provide zone and/or mission data
 * The probability may need some tweaking
 */
void WreckAnalysis(int number, int color, __int16 ypos, __int16 xpos, int useSmallFonts)
{
	DrawNumber2(number, color, ypos, xpos, useSmallFonts);

	int recoveredNavigation=tac_misdata[2];
	int i;
	int discoverZone=0;
	int discoverMission=0;
	char buf[256];
	char format[256];

	char victoryStatus=tac_misdata[0x4e];
	char missionDescriptor=tac_misdata[0x14];

	//Only work on successful ground missions
	if(victoryStatus != 1 && missionDescriptor != 0 )
		return;

	//"analyze" each navigation module
	for(i=0;i<recoveredNavigation;i++)
	{
		if(GetRandom_0_n(100)<20-*difficultyLevel*2)
		{
			discoverZone=1;
		}
		if(GetRandom_0_n(100)<20-*difficultyLevel*2)
		{
			discoverMission=1;
		}
	}


	char locIdx=tac_misdata[0x4c];
	char ufoIdx=(*locationList+20*locIdx)[1];
	int type=(*craftList+104*ufoIdx)[28];
	int zone=(*craftList+104*ufoIdx)[30];
	int race=(*craftList+104*ufoIdx)[36];
	
	char *missionName=StringTable_geoscape[558+type];
	char *zoneName=StringTable_geoscape[543+zone];
	char *raceName=StringTable_geoscape[466+race];


	if(discoverMission&&discoverZone)
	{
		INI_READ_STRING("Wreck Analysis","Both Discovered","Ship investigation revealed that the %s UFO was on an %s mission in %s",format,256);
		sprintf(buf,format,raceName,missionName,zoneName);
	}
	else if(discoverMission)
	{
		INI_READ_STRING("Wreck Analysis","Mission Discovered","Inspection showed that the %s UFO was on an %s mission",format,256);
		sprintf(buf,format,raceName,missionName);
	}
	else if(discoverZone)
	{
		INI_READ_STRING("Wreck Analysis","Zone Discovered","Intel found out that the %s UFO was raiding %s",format,256);
		sprintf(buf,format,raceName,zoneName);
	}
	else
	{
		return;
	}

	*DrawText_rightBorder=320-16;
	DrawString(buf,0x8b,ypos+16,16,1);
}


/*
 * Draw the rank icon in the equipment screen
 */
void DrawRank(char *str, int color, __int16 ypos, __int16 xpos, int smallFont)
{
	DrawString(str,color,ypos,xpos+32,smallFont);
	char **unitref=(char **)0x4783C4;
	if((*unitref)[0]>2) //aliens have no rank icons
		return;

	int rank=(*unitref)[0x2a];
	short oldGFX=*currentGFXPackage;

	LoadGFXRessources(1);
	
	char *icon=*smokePCKRessources+*(*smokeTabRessources+20+rank);
	DrawRankIcon((int)*BackBuffer,(int)icon,32);

	LoadGFXRessources(oldGFX);
}

/*
 * Fix for the base disjoint bug
 * We scan the border modules and fix the tiles when needed
 */
void BaseDisjointFix()
{
	((void (*)())(0x41BF90))();

	unsigned char *modules=&(pGeodata[12]);
	int *groundTiles=&((*pMap)[(*map_numTilesPerLevel)]);

#define MODULE(X,Y) modules[(X)+6*(Y)]
#define TILE(X,Y) groundTiles[(X)+60*(Y)]


	for(int i=0;i<5;i++)
	{
		int j=4;
		{
			if(MODULE(i,j)>=(unsigned char)0x14)
				continue;
			if(MODULE(i,j)==0x10)
				continue;
			if(MODULE(i,j)>=(unsigned char)0x11)
				continue;
			if(MODULE(i,j+1)>(unsigned char)0x14)
				continue;

			char *tile1=(char *)&TILE(i*10+9,(j+1)*10+3);
			char *tile2=(char *)&TILE(i*10+9,(j+1)*10+4);
			char *tile3=(char *)&TILE(i*10+9,(j+1)*10+5);

			char *tile4=(char *)&TILE(i*10+10,(j+1)*10+3);
			char *tile5=(char *)&TILE(i*10+10,(j+1)*10+4);
			char *tile6=(char *)&TILE(i*10+10,(j+1)*10+5);

			char *tile7=(char *)&TILE(i*10+9,(j+1)*10+6);

			tile1[0]=9;
			tile1[1]=0;
			tile1[2]=16;
			tile1[3]=0;

			tile2[0]=9;
			tile2[1]=0;
			tile2[2]=0;
			tile2[3]=0;

			tile3[0]=9;
			tile3[1]=0;
			tile3[2]=0;
			tile3[3]=0;

			//Remove west wall
			tile4[1]=0;
			tile5[1]=0;
			tile6[1]=0;

			tile7[2]=16;
		}
	}


	int i=4;
	{
		for(int j=0;j<5;j++)
		{
			if(MODULE(i,j)>=(unsigned char)0x14)
				continue;
			if(MODULE(i,j)==0x11)
				continue;
			if(MODULE(i+1,j)>(unsigned char)0x14)
				continue;

			char *tile1=(char *)&TILE((i+1)*10+3,j*10+9);
			char *tile2=(char *)&TILE((i+1)*10+4,j*10+9);
			char *tile3=(char *)&TILE((i+1)*10+5,j*10+9);

			char *tile4=(char *)&TILE((i+1)*10+3,j*10+10);
			char *tile5=(char *)&TILE((i+1)*10+4,j*10+10);
			char *tile6=(char *)&TILE((i+1)*10+5,j*10+10);

			char *tile7=(char *)&TILE((i+1)*10+6,j*10+9);

			tile1[0]=9;
			tile1[1]=15;
			tile1[2]=0;
			tile1[3]=0;

			tile2[0]=9;
			tile2[1]=0;
			tile2[2]=0;
			tile2[3]=0;

			tile3[0]=9;
			tile3[1]=0;
			tile3[2]=0;
			tile3[3]=0;

			//Remove north wall
			tile4[2]=0;
			tile5[2]=0;
			tile6[2]=0;

			tile7[1]=15;
		}
	}
}

/*
 * Trigger reaction fire when units turn
 * The two functions are called when the unit's orientation change
 */
void ReactionFire1()
{
	((void (*)())(0x42DD50))();
	PerformReactionFire();
}

void ReactionFire2(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
{
	ComputeVisibleAliens(xpos, ypos, zpos, orientation, distance);
	PerformReactionFire();
}

/*
 * We replace the standard radar coverage calculation by this one which
 * takes radar stacking into account
 */
void FixRadarStacking(__int16 baseIdx)
{
	unsigned char *base=(*pBaseList)+baseIdx*292;
	unsigned char *modules=&base[22];
	unsigned char *completion=&base[58];
	int smallRadars=0;
	int largeRadars=0;
	int hwd=0;

	//Scan base modules
	for(int i=0;i<6;i++)
	{
		for(int j=0;j<6;j++)
		{
			if(*completion==0)
			{
				switch(*modules)
				{
				case 4://small radar
					smallRadars++;
					break;
				case 5://large radar
					largeRadars++;
					break;
				case 15://hyper wave decoder
					hwd++;
					break;
				}
			}
			modules++;
			completion++;
		}
	}

	float shortDetection=pow(0.9f,smallRadars);
	float largeDetection=pow(0.8f,largeRadars);

	*(short *)(&base[0x10])=(short)((1.0-shortDetection*largeDetection)*100.0);
	*(short *)(&base[0x12])=(short)((1.0-largeDetection)*100.0);
	*(short *)(&base[0x14])=hwd?100:0;
}

/*
 * Repopulate the activated proximity grenade list during each loop of the battlescape.
 * This is crude but effective. As an added bonus, it reduces the speed of the game ;-)
 * Better solution would be to update it only during unit movement.
 */
void FixProximityMines()
{
	for(int i=0;i<20;i++)
		tac_prox_mine_list[i].active=0;

	int mine_idx=0;

	for(int i=0;i<170;i++)
	{
		char *pObpos=&pObpos_dat[i*16];
		if(pObpos[0]==0x15&&pObpos[8]==1&&pObpos[4]==-1) //armed prox mine on the ground
		{
			tac_prox_mine_list[mine_idx].active=1;
			tac_prox_mine_list[mine_idx].pObpos=pObpos;
			mine_idx++;
			if(mine_idx==20)
				break;
		}
	}

	ActAccordingToTacticalState();
}

/*
 * Explosions give experience to the "current unit". For proxmines, developers forget to change it before generating
 * the explosion and the experience does not go to the correct unit.
 */
void FixProximityMinesExperience(int xpos, int ypos, __int16 zpos, int strength, int a, int b, __int16 c)
{
	unsigned char *pObpos;
	unsigned char thrower_idx;
	
	//save the current unit
	short saved_idx=*currentUnit_idx;

	__asm 
	{
		mov eax,[esi+2];
		mov pObpos,eax;
	}

	//set current unit to the thrower
	thrower_idx=pObpos[9];
	SetCurrentUnit(thrower_idx);
	
	//boom!
	GenerateExplosion(xpos, ypos, zpos, strength, a, b, c);

	//restore the current unit
	SetCurrentUnit(saved_idx);
}

/*
 * Helper to draw dialog boxes
 */
void DrawDialog(char *line1, char *line2)
{
	((void (*)(int,int,int,int,int))(0x41E3F0))(0x30,0x32,0x58,0xDC,1);
	*DrawText_leftBorder=0xA0;
	DrawString(line1,0x10,0x40,0x50,0);
	*DrawText_leftBorder=0xA0;
	DrawString(line2,0x10,0x50,0x50,0);
	*ui_numButtons=0;

	//"OK" button
	CreateButton(0x70,0x64,0x12,0x78,0x10,StringTable_battlescape[77]);

	((void (*)(int))(0x42F680))(1);

	WaitTillMouseButtonsAreReleased();
	while(!CheckForClickedButton());
}

/*
 * Elerium ships have a constant consumption rate of 1 (for standard ship, consumption is based on ship speed).
 * This rate is used at 2 places: to know when the ship has burnt half its fuel, and to determine how much distance
 * it can still fly. The second part is buggy however and uses the standard ship formula so we end up with a fly distance
 * of 0 and the ship returns immedialty. This should fix the issue.
 */
__declspec(naked) void EleriumShipFix()
{
	__asm
	{
		mov eax,edi
		cdq
		
		cmp bl,0
		jz std_fuel
		cmp bl,3
		jz std_fuel
		ret
std_fuel:
		idiv ecx
		ret
	}
}

/*
 * Call the KillUnit function when an unconscious corpse is destroyed.
 * The KillUnit function generates a body and we don't want that. To prevent
 * it, we find which obpos will be used for the body (gotten GetFreeObPosRef)
 * and clear the object after we called the function. Sinec big units can use
 * 4 objects, we check the 4 next obpos.
 */
void ObjectDestroyed(unsigned char *pObpos)
{
	int flags=pObpos[12];
	if(flags&8) //unconscious corpse
	{
		int obtype=pObpos[0];
		if(obtype>=58&&obtype<=77) //big units: get out
			return;

		short corpse[4];
		int unitidx=pObpos[8];
		char *unitpos=&(unitpos_dat)[14*unitidx];
		char *unitref=*(char **)&(unitpos[4]);

		//save the next 4 free obpos
		for(int i=0;i<4;i++)
		{
			corpse[i]=GetFreeObPosRef();
		}

		Tactical_KillUnit(unitidx);

		//clear the obpos since they contain body objects
		for(int i=0;i<4;i++)
		{
			if(corpse[i]!=-1)
				pObpos_dat[16*corpse[i]]=0xff;
		}

		DrawDialog(&unitref[0x56],"got blasted");
	}
}

//Call the ObjectDestroyed function instead of just destroying the object by clearing if objType field
__declspec(naked) void CheckDestroyObject()
{
	__asm
	{
		jbe skip
		pusha
			
		sub esi,6
		push esi
		call ObjectDestroyed
		add esp,4

		popa
		mov     [esi-6], bl
skip:
		ret
	}
}

/*
 * Apply patches according to the ini file
 */
void ApplyPatches()
{
	InsertCall(0x44C6E9,ShowMod);

/*
	//force retaliation
	{
		char patch[]={0x90,0x90,0x90,0x90,0x90,0x90};
		PatchInPlace(0x432AD8,patch,6);
		PatchInPlace(0x432B06,patch,2);
		PatchInPlace(0x4594BD,patch,6);
	}
//*/

#ifdef HEAVY_LASER_MOD
	{
		//Hook tile drawing procedure
		InsertCall(0x4251E7,DrawWaypoints);
		InsertCall(0x425AF8,DrawWaypoints);
		InsertCall(0x425E04,DrawWaypoints);

//041FE37 83 F8 12
		char patch_maxstates[]={0x14};
		PatchInPlace(0x41FE39,patch_maxstates,1);
		
//41FFC4 90 90 90 90
		int patch_newstate=(int)&FullAutoMode;
		PatchInPlace(0x41FFC4,(char *)&patch_newstate,4);
		patch_newstate=(int)&ControlledBurstMode;
		PatchInPlace(0x41FFC8,(char *)&patch_newstate,4);


		InsertJmp(0x41DA59,BurstPopulateMenu);

		int patch_addmode=(int)&SetFullAutoMode;
		PatchInPlace(0x41D168+4*4,(char *)&patch_addmode,4);
		patch_addmode=(int)&SetControlledBurstMode;
		PatchInPlace(0x41D168+4*5,(char *)&patch_addmode,4);

		InsertJmp(0x418D38,BurstPatchResources);
	}
#endif

//crafts always ready
	if(INI_READ_INT("Mod","Crafts Always Ready",0))
	{
		//Check fuel level instead of state
		char patch[]={0x18,0x20,0x7c};
		PatchInPlace(0x45174E+4,patch,3);
	}
	if(INI_READ_INT("Mod","Stunned units KIA",0))
	{
		InsertCall(0x40CEB3,CheckDestroyObject);
	}

#ifdef NDEBUG
	if(INI_READ_INT("Bug Fix","Video Pitch",0))
#endif
	{
		InsertJmp(0x42FF10,FixPitch);
	}

	
	if(INI_READ_INT("Mod","No Blaster Bomb Drift",0))
	{
		char patch[]={0x90,0x90,0x90,0x90,0x90};
		PatchInPlace(0x426E78,patch,5);
		PatchInPlace(0x40595F,patch,5);
	}
	else if(INI_READ_INT("Bug Fix","Collectors Edition Blaster Bomb Bug",0))
	{
		InsertCall(0x426E78,FixedAccuracyCompensation);
		InsertCall(0x40595F,FixedAccuracyCompensation);
	}

	if(INI_READ_INT("Mod","More Reaction Fire",0))
	{
		InsertCall(0x42192B,ReactionFire1);
		InsertCall(0x421921,ReactionFire2);
	}

	if(INI_READ_INT("Mod","Manual Interception Fire Mode",0))
	{
		char patch[]={0x90,0x90,0x90,0x90,0x90,0x90};
		
		PatchInPlace(0x446B61,patch,2);
		PatchInPlace(0x446AE8,patch,6);

	//disable damage
	//	PatchInPlace(0x446E48,patch,4);
		
	}

#ifdef NDEBUG
	if(INI_READ_INT("Mod","Skip Intro",0))
#endif
	{
		char patch[]={0x90,0x90,0x90,0x90,0x90};
		PatchInPlace(0x45E69F,patch,5);
	}



	if(INI_READ_INT("Equipment Screen","Apply",0)) 
	{
		//Revert old equipment screen patch in case the binary has already been hand patched
		char revert[]={ 0x5F, 0x5E, 0x5D, 0x5B, 0xC3 };
		//Patch coordinates of "TUs>" string
		char patchy[]={ 0x18+8 };
		char patchx[]={ 0xFA-5 };
		PatchInPlace(0x41947E,revert,5);
		PatchInPlace(0x418E9E,patchy,1);
		PatchInPlace(0x418E99,patchx,1);
		InsertJmp(0x419482,ShowEncumberance);
	}

#ifdef NDEBUG
	if(INI_READ_INT("Music","Apply",0)) 
#endif
	{
		//mov CurrentMidiPlaying, esi
		//pop edi
		//pop esi
		char patch_music[]={ 0x89, 0x35, 0xE8, 0x58, 0x47, 0x00, 0x5F, 0x5E };
		PatchInPlace(0x45D991,patch_music,8);
		InsertJmp(0x45D991+8,PlayCDMusic);
		//Add stop music call after DirectDraw de-init routine. There is enough padding there :p
		InsertJmp(0x45C7A5,StopCDMusic);
	}

	if(INI_READ_INT("Wreck Analysis","Apply",0))
	{
		InsertCall(0x4482B0,WreckAnalysis);
	}

/////////////////Bug Fixes/////////////////////

	//elerium ships
	if(INI_READ_INT("Bug Fix","Elerium-fueled Craft Bug",0))
	{
		InsertCall(0x4421AC,EleriumShipFix);
	}

	if(INI_READ_INT("Bug Fix","Transfered Crafts Refueled",0))
	{
//		044151F 66 C7 44 10 18 00 00    
		char patch[]={0x90,0x90,0x90,0x90,0x90,0x90,0x90};
		PatchInPlace(0x44151F,patch,7);
	}


	if(INI_READ_INT("Bug Fix","Radar Stacking",0))
	{
		InsertJmp(0x439D10,FixRadarStacking);
	}


//0441AB9 0F 8D AB 01 00 00
//0441AB9 0F 83 AB 01 00 00
	if(INI_READ_INT("Bug Fix","Base Facility Dismantle-Construction Crash",0))
	{
		char patch[]={0x83};
		PatchInPlace(0x441ABA,patch,1);
	}


#ifdef NDEBUG
	if(INI_READ_INT("Bug Fix","Tactical Scroll",0))
#endif
	{
		char patch_vsync[]={DDFLIP_WAIT};
		PatchInPlace(0x45C89D,patch_vsync,1); 
		InsertCall(0x4147D5,TimeFix);
		char patch[]={0x90,0x90};
		PatchInPlace(0x45C891,patch,2); 
		
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades",0)) 
	{
		InsertCall(0x42A7D6,FixProximityMines);
	}

	if(INI_READ_INT("Bug Fix","Proximity Grenades Experience",0))
	{
		InsertCall(0x41E239,FixProximityMinesExperience);
	}

	if(INI_READ_INT("Bug Fix","Pay For Dirt",0)) 
	{
		char patch[]={0xff, 0xff, 0xff, 0xff};
		PatchInPlace(0x43BE4E,patch,4);
	}

	if(INI_READ_INT("Bug Fix","Phantom Radar",0)) 
	{
		char patch[]={0xeb, 0x43A2D2-0x43A290-5};
		PatchInPlace(0x43A290,patch,2);
		InsertJmp(0x43A2D5,PhantomRadarFix);
	}

	if(INI_READ_INT("Bug Fix","Base Disjoint",0))
	{
		InsertCall(0x41AFCA,BaseDisjointFix);
	}
/////////////////Enhancements///////////////////
	
#ifdef NDEBUG
	if(INI_READ_INT("Mod","Save Reserve Mode",0)) 
#endif
	{
		InsertCall(0x401014,SaveReserveMode);
		InsertCall(0x4012F6,RestoreReserveMode);
	}

	if(INI_READ_INT("Mod","Hot Grenades",0)) 
	{
		char patch[]={0x90, 0x90, 0x90, 0x90, 0x90, 0x90};
		PatchInPlace(0x41E095,patch,6);
	}

	if(INI_READ_INT("Mod","Alien Inventory",0)) 
	{
		char patch[]={0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90, 0x90};
		PatchInPlace(0x412A20,patch,8);
	}

	if(INI_READ_INT("Mod","Retaliate Against Ground Assault",0)) 
	{
		InsertCall(0x44720A,RetaliationAfterGroundAssault);
	}

	if(INI_READ_INT("Mod","Rank In Inventory",0)) 
	{
		InsertCall(0x41A581,DrawRank);
		InsertCall(0x418E8C,DrawRank);
	}

//////////////////Hacks////////////////////
#ifdef NDEBUG
	if(INI_READ_INT("Hack","No Score Game Over",0)) 
#endif
	{
		char patch[]={0xeb};
		PatchInPlace(0x43C1AC,patch,1);
	}

	if(INI_READ_INT("Hack","No Alien Psi",0)) 
	{
		char patch[]={0xC3};
		PatchInPlace(0x404650,patch,1);
	}

	InsertJmp(0x425455,DebugFlagsCheck);

	if(INI_READ_INT("Hack","Directly Use Alien Weapons",0)) 
	{
		char patch[]={0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90};
		PatchInPlace(0x41CD5C,patch,12);
		PatchInPlace(0x45694C,patch,2);
	}

	if(INI_READ_INT("Hack","Recover All Clips",0))
	{
		char patch[]={0x90,0x90};
		PatchInPlace(0x447D6D,patch,2);
	}
}
